#include "config.h"

#include <stdlib.h>

#include "defines.h"

void mask_site(int nsites,M_SITE *site,SAMPLE *data,MODEL *model,int two_motif_model) {

   int i,j;
   int s,loc; // motif 2 seqID, location

   for (i=0; i<nsites; i++) {
     // if two-motif model, mask the secondary motif
     if (two_motif_model) {
        loc=site[i].loc[1];
        s=site[i].seq;
        if (loc!=DUMMY_LOCATION) {
           for (j=0; j<model->pwmLenNew[1]; j++) data[s].seq[loc+j]='n';
         }
      }
     // if one-motif model, mask the motif
      else {
        loc=site[i].loc[0];
        s=site[i].seq;
        if (loc!=DUMMY_LOCATION) {
           for (j=0; j<model->pwmLenNew[0]; j++) data[s].seq[loc+j]='n';
         }
      }
   }
}

